hdu 3635 Dragon Balls(高级并查集)

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3635

Five hundred years later, the number of dragon balls will increase unexpectedly, so it's too difficult for Monkey King(WuKong) to gather all of the dragon balls together.

hdu 3635 Dragon Balls(高级并查集)_第1张图片


His country has N cities and there are exactly N dragon balls in the world. At first, for the ith dragon ball, the sacred dragon will puts it in the ith city. Through long years, some cities' dragon ball(s) would be transported to other cities. To save physical strength WuKong plans to take Flying Nimbus Cloud, a magical flying cloud to gather dragon balls.
Every time WuKong will collect the information of one dragon ball, he will ask you the information of that ball. You must tell him which city the ball is located and how many dragon balls are there in that city, you also need to tell him how many times the ball has been transported so far.

 

 

Input

The first line of the input is a single positive integer T(0 < T <= 100).
For each case, the first line contains two integers: N and Q (2 < N <= 10000 , 2 < Q <= 10000).
Each of the following Q lines contains either a fact or a question as the follow format:
  T A B : All the dragon balls which are in the same city with A have been transported to the city the Bth ball in. You can assume that the two cities are different.
  Q A : WuKong want to know X (the id of the city Ath ball is in), Y (the count of balls in Xth city) and Z (the tranporting times of the Ath ball). (1 <= A, B <= N)

 

 

Output

For each test case, output the test case number formated as sample output. Then for each query, output a line with three integers X Y Z saparated by a blank space.

 

 

Sample Input

 

2 3 3 T 1 2 T 3 2 Q 2 3 4 T 1 2 Q 1 T 1 3 Q 1

 

 

Sample Output

 

Case 1: 2 3 0 Case 2: 2 2 1 3 3 2

 

题意:T a b 代表将a所在的集合挂在b上,Q a总共询问3个信息:①a所在的集合,(这个很好办,find(a)的返回值就是答案);②a所在的集合中元素的个数,(这个也很容易,用一个size[]数组在合并的时候维护一下就可以了);③a移动的次数,这个就难办了,因为路径压缩会破坏原本的树结构,如果我设一个sum[]数组,那么需要在路径压缩的时候维护它,比如说 T 1 2, T 1 3
当1和3合并的时候,实际上是f[2]=3;sum[2]++;此时sum[1]仍然等于1,所以当我们查找1时,首先会找的1的祖先是2,这时令sum[1]+=sum[2];即向上回溯祖先是,要将转移次数加给子孙。然后会找到2的祖先是3.

#pragma GCC optimize(2)
#include
#include
#include
#include
#include
#include
#include
using namespace std;
const int maxn = 50010;
const int inf = 0x3f3f3f3f;
typedef long long ll;
int f[maxn], num[maxn], sum[maxn];
int t, n, m;
void init(int n)
{
	for (int i = 0; i <= n; i++)
	{
		f[i] = i;
		num[i] = 1;
		sum[i] = 0;
	}
	return;
}
int find(int x)
{
	if(x!=f[x])
	{
		int t = f[x];
		f[x] = find(f[x]);
		sum[x] += sum[t];
		return f[x];
	}
	return x;
}
void _union(int x, int y)
{
	int fx = find(x);
	int fy = find(y);
	if (fx == fy)
	{
		return;
	}
	else
	{
		f[fx] = fy;
		num[fy] += num[fx];
		sum[fx]++;
	}
	return;
}
int main()
{
	//freopen("C://input.txt", "r", stdin);
	scanf("%d", &t);
	int cas = 1;
	char str[5];
	while (t--)
	{
		int n, m;
		scanf("%d%d", &n, &m);
		printf("Case %d:\n", cas++);
		init(n);
		while (m--)
		{
			int u, v;
			scanf("%s", str);
			if (str[0] == 'T')
			{
				scanf("%d%d", &u, &v);
				_union(u, v);
			}
			if (str[0] == 'Q')
			{
				scanf("%d", &u);
				int ans = find(u);
				printf("%d %d %d\n", ans, num[ans], sum[u]);
			}
		}
	}
	return 0;
}

 

你可能感兴趣的:(并查集)